abuild.in 30.9 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
abuildrepo=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
14
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
15

16
program=${0##*/}
17
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
18 19

# defaults
20
BUILD_BASE="build-base"
21
SUDO=${SUDO:-"sudo"}
22
FAKEROOT=${FAKEROOT:-"fakeroot"}
23
APK=${APK:-apk}
24

Natanael Copa's avatar
Natanael Copa committed
25
# read config
Natanael Copa's avatar
Natanael Copa committed
26
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
27 28
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

29
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
30 31 32 33 34 35
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
36 37 38 39 40 41 42 43 44 45 46 47 48 49
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
Natanael Copa's avatar
Natanael Copa committed
50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73
fi	
	

# functions
msg() {
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	[ -z "$quiet" ] && printf "${prompt} ${name}${fake}: $@\n" >&2
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}
Natanael Copa's avatar
Natanael Copa committed
74 75

	
Linux User's avatar
Linux User committed
76
set_xterm_title() {
77
	if [ "$TERM" = xterm ] && [ -n "$USE_COLORS" ]; then
78
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
79 80 81 82 83
	fi
} 

cleanup() {
	set_xterm_title ""
84
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
85
		$SUDO $APK del $uninstall_after
86
	fi
Linux User's avatar
Linux User committed
87 88
}

Natanael Copa's avatar
Natanael Copa committed
89
die() {
Linux User's avatar
Linux User committed
90
	error "$@"
Linux User's avatar
Linux User committed
91
	cleanup
Natanael Copa's avatar
Natanael Copa committed
92 93 94
	exit 1
}

95 96
# check if apkbuild is basicly sane
sanitycheck() {
97
	local i suggestion
98
	msg "Checking sanity of $APKBUILD..."
99 100 101
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
102
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
103
		$APK version --check -q "$pkgver" ||\
Natanael Copa's avatar
Natanael Copa committed
104 105
			die "$pkgver is not a valid version"
	fi
106
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
107 108 109 110
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

111 112 113 114 115 116 117 118 119 120
	# check if CARCH, CBUILD, CHOST and CTARGET is set
	if [ -z "$CARCH" ]; then
		case "$(uname -m)" in
		i[0-9]86) suggestion=" (Suggestion: CARCH=x86)";;
		x86_64) suggestion=" (Suggestion: CARCH=x86_64)";;
		esac
		die "Please set CARCH in /etc/abuild.conf$suggestion"
	fi
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

Natanael Copa's avatar
Natanael Copa committed
121 122 123 124 125 126 127
	for i in $install; do
		[ -e "$startdir/$i" ] || die "install script $startdir/$i is missing"
	done
	
	[ -n "${triggers%%:*}" ] && [ ! -e "$startdir"/${triggers%%:*} ] \
		&& die "trigger script $startdir/${triggers%%:*} is missing"

128 129
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
130 131 132 133
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
134
			md5sums_has ${i##*/} || die "${i##*/} is missing in md5sums"
Natanael Copa's avatar
Natanael Copa committed
135 136 137
			case "$i" in
				https://*) makedepends_has wget || die "wget must be in makedepends when source has https://" ;;
			esac
138 139
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
140

141 142
	if [ -n "$md5sums" ]; then
		for i in $(echo "$md5sums" | awk '{ print $2 }'); do
Natanael Copa's avatar
Natanael Copa committed
143
			source_has $i || die "$i exists in md5sums but is missing in source"
144 145
		done
	fi
146

147 148 149
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
150 151

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
152 153

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
154 155 156 157
	return 0
}

md5check() {
Natanael Copa's avatar
Natanael Copa committed
158
	local dummy f
159 160 161
	if [ -z "$source" ]; then
		return 0
	fi
162
	if [ -z "$md5sums" ]; then
163
		die "Use 'abuild checksum' to generate/update the checksum(s)"
164
	fi
165 166 167
	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi
168
	fetch || return 1
169
	msg "Checking md5sums..."
170
	cd "$srcdir" && echo "$md5sums" | md5sum -c 
Natanael Copa's avatar
Natanael Copa committed
171 172
}

Natanael Copa's avatar
Natanael Copa committed
173 174
# verify upstream sources
sourcecheck() {
175 176 177 178 179 180 181 182 183 184
	local uri
	for uri in $source; do
		is_remote $uri || continue
		case "$uri" in
		saveas-*://*)
			uri=${uri#saveas-}
			uri=${uri%/*}
			;;
		esac
		wget -q -s "$uri" || return 1
Natanael Copa's avatar
Natanael Copa committed
185
	done
186
	return 0
Natanael Copa's avatar
Natanael Copa committed
187
}
188

Natanael Copa's avatar
Natanael Copa committed
189 190
uri_fetch() {
	local uri="$1"
191
	local d="${uri##*/}"	# $(basename $uri)
192 193 194 195
	local opts
	[ -n "$quiet" ] && opts="-q"
	[ -f "$SRCDEST/$d" ] && return 0

196 197 198 199 200
	# fix saveas-*://* URIs
	case "$uri" in
		# remove 'saveas-' from beginning and
		# '/filename' from end of URI
		saveas-*://*) uri="${uri:7:$(expr ${#uri} - 7 - ${#d} - 1)}";;
Natanael Copa's avatar
Natanael Copa committed
201
	esac
202 203 204 205 206

	# we need GNU wget for this
	case "$uri" in
		https://*) opts="--no-check-certificate";;
	esac
Natanael Copa's avatar
Natanael Copa committed
207
	
Natanael Copa's avatar
Natanael Copa committed
208
	mkdir -p "$SRCDEST"
209 210 211
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
		opts="$opts -c"
Natanael Copa's avatar
Natanael Copa committed
212
	fi
Linux User's avatar
Linux User committed
213
	msg "Fetching $uri"
214 215
	wget $opts -O "$SRCDEST/$d.part" "$uri" \
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
Natanael Copa's avatar
Natanael Copa committed
216 217
}

218 219
is_remote() {
	case "$1" in
220
		http://*|ftp://*|https://*|saveas-*://*)
221 222 223 224 225
			return 0;;
	esac
	return 1
}

226 227 228 229 230
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	local d="${uri##*/}"	# $(basename $uri)
	if [ -n "$DISTFILES_MIRROR" ]; then
231 232 233 234 235
		if is_remote "$DISTFILES_MIRROR"; then
			uri_fetch "$DISTFILES_MIRROR"/$d && return 0
		else
			cp "$DISTFILES_MIRROR"/$d "$SRCDEST" && return 0
		fi
236 237 238 239
	fi
	uri_fetch "$uri"
}

240
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
241 242
	local s
	mkdir -p "$srcdir"
243 244
	for s in $source; do
		if is_remote "$s"; then
245
			uri_fetch_mirror "$s" || return 1
246 247 248 249
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
250 251 252
	done
}

253 254 255 256
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
257 258 259 260 261 262 263 264 265 266 267 268 269 270 271
# verify that all init.d scripts are openrc runscripts
initdcheck() {
	local i
	for i in $source; do
		case $i in
		*.initd)
			head -n 1 "$srcdir"/$i | grep -q '/sbin/runscript' \
				&& continue
			error "$i is not an openrc #!/sbin/runscript"
			return 1
			;;
		esac
	done			
}

Natanael Copa's avatar
Natanael Copa committed
272
# unpack the sources
273
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
274
	local u
275 276
	if [ -z "$force" ]; then
		md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
277
		initdcheck || return 1
278
	fi
Natanael Copa's avatar
Natanael Copa committed
279 280 281 282
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
Natanael Copa's avatar
Natanael Copa committed
283
			*.tar.gz|*.tgz)
284
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
285 286
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
287
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
288
				tar -C "$srcdir" -jxf "$s" || return 1;;
289 290 291 292
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
293 294 295
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
296 297 298
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
299 300 301 302
		esac
	done
}

303 304 305 306
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
307 308
# cleanup source and package dir
clean() {
309
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
310
	rm -rf "$srcdir"
311
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
312 313 314 315 316 317
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
318 319 320 321
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
322 323 324
	done
}

325 326 327 328 329 330 331 332 333 334
listpkgnames() {
	local i
	for i in $pkgname $subpackages; do
		echo ${i%:*}
	done
	for i in $linguas; do
		echo $pkgname-lang-$i
	done
}

Natanael Copa's avatar
Natanael Copa committed
335 336
cleanpkg() {
	local i
337
	getpkgver || return 1
338
	msg "Cleaning built packages..."
339
	for i in $(listpkgnames); do
340 341
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
342
			"$abuildrepo"/$p.apk
Natanael Copa's avatar
Natanael Copa committed
343
	done
344
	# remove given packages from index
Natanael Copa's avatar
Natanael Copa committed
345 346
}

347 348 349
# clean all packages except current
cleanoldpkg() {
	local i j
350
	getpkgver || return 1
351
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
352
	for i in $(listpkgnames); do
353 354 355 356 357 358 359
		for j in "$PKGDEST"/${i%:*}-[0-9]*.apk; do
			[ "$j" != "$PKGDEST/${i%:*}-$pkgver-r$pkgrel.apk" ] \
				&& rm -f "$j"
		done
	done
	return 0
}
360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377

mkusers() {
	local i
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
			msg "Creating user $i"
			$SUDO adduser -D -H $i || return 1
		fi
	done
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$SUDO addgroup $i || return 1
		fi
	done
}


Natanael Copa's avatar
Natanael Copa committed
378 379
runpart() {
	local part=$1
380
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
381 382 383 384
	$part || die "$part failed"
}

# override those in your build script
385 386 387 388 389 390 391 392
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
393 394 395 396
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
397
build() {
398
	:
Natanael Copa's avatar
Natanael Copa committed
399 400
}

401 402 403 404 405 406
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

Natanael Copa's avatar
Natanael Copa committed
407 408 409 410 411 412 413 414 415
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

416
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
417 418
	local i
	cd "$startdir"
419
	for i in $subpackages; do
Natanael Copa's avatar
Natanael Copa committed
420 421
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
422
		msg "Running split function $func..."
423
		subpkgdir="$pkgbasedir/${i%:*}" subpkgname="${i%:*}" \
424
			$0 $func prepare_package || return 1
Natanael Copa's avatar
Natanael Copa committed
425 426 427
	done
}

428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449
lang_subpkg() {
	if [ -z "$lang" ]; then
		error "lang is not set"
		return 1
	fi
	arch="noarch"
	install_if="$pkgname=$pkgver-r$pkgrel lang-$lang"
	mkdir -p "$subpkgdir"/usr/share/locale
	mv "$pkgdir"/usr/share/locale/$lang* \
		"$subpkgdir"/usr/share/locale/ \
		|| return 1
}

prepare_language_packs() {
	for lang in $linguas; do
		lang="$lang" \
		subpkgname="$pkgname-lang-$lang" \
		subpkgdir="$pkgbasedir"/$subpkgname \
			$0 lang_subpkg prepare_package || return 1
	done
}

450
prepare_metafiles() {
451
	getpkgver || return 1
452 453
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
454
	local dir=${subpkgdir:-$pkgdir}
455
	local pkg="$name-$pkgver-r$pkgrel.apk"
456
	local pkginfo="$controldir"/.PKGINFO
457
	local sub
Natanael Copa's avatar
Natanael Copa committed
458 459 460
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
461
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
462 463
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
464 465 466 467
	local parch="$CARCH"
	if [ "$arch" = "noarch" ]; then
		parch="noarch"
	fi
Natanael Copa's avatar
Natanael Copa committed
468

469
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
470
	if [ -n "$FAKEROOTKEY" ]; then
471
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
472
	fi
473 474
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
475
pkgname = $name
476
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
477 478 479 480 481
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
482
arch = $parch
Natanael Copa's avatar
Natanael Copa committed
483
EOF
484 485
	local i deps
	deps="$depends"
486
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
Natanael Copa's avatar
Natanael Copa committed
487 488
		for i in $install ${triggers%%:*}; do
			if head -n 1 "$startdir/$i" | grep '^#!/bin/sh' >/dev/null ; then
489 490 491 492 493
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
494 495
	fi
	
Natanael Copa's avatar
Natanael Copa committed
496
	for i in $license; do
497
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
498 499
	done
	for i in $replaces; do
500
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
501
	done
502
	for i in $deps; do
503
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
504 505
	done
	for i in $conflicts; do
506
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
507 508
	done
	for i in $provides; do
509
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
510
	done
Natanael Copa's avatar
Natanael Copa committed
511 512 513
	if [ -n "$triggers" ]; then
		echo "triggers = ${triggers#*:}" >> "$pkginfo"
	fi
514 515 516
	if [ -n "$install_if" ]; then
		echo "install_if = $(echo $install_if)" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
517 518

	local metafiles=".PKGINFO"
Natanael Copa's avatar
Natanael Copa committed
519
	for i in $install ${triggers%%:*}; do
520 521
		script=${i#$name}
		case "$script" in
Natanael Copa's avatar
Natanael Copa committed
522
			.pre-install|.post-install|.pre-upgrade|.post-upgrade|.pre-deinstall|.post-deinstall|.trigger)
523 524
				msg "Adding $script"
				;;
Natanael Copa's avatar
Natanael Copa committed
525
			*) 	error "$script: Invalid install/trigger script"
526 527 528
				return 1
				;;
		esac
Natanael Copa's avatar
Natanael Copa committed
529
		cp "$startdir/$i" "$controldir/$script" || return 1
530
		chmod +x "$controldir/$script"
531 532
		metafiles="$metafiles $script"
	done
533
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
534
}
535

536 537
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
538
	[ "$arch" = "noarch" ] && return 0
539
	options_has "!tracedeps" && return 0
540
	# lets tell all the .so files this package provides in .provides-so
541 542
	find -name '*.so' -o -name '*.so.[0-9]*' | sed 's:.*/::' \
		>"$controldir"/.provides-so
543 544 545 546 547
	# lets tell all the places we should look for .so files - all rpaths
	scanelf -q -Rr "$dir" | sed -e 's/[[:space:]].*//' -e 's/:/\n/' \
		| sort | uniq \
		>"$controldir"/.rpaths
	# now find the so dependencies
548
	scanelf -Rn "$dir" | tr ' ' ':' | awk -F ":" '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
549 550 551
		| sed 's:,:\n:g' | sort | uniq \
	| while read i; do
		# only add files that are not self provided
552 553
		grep "^$i$" "$controldir"/.provides-so >/dev/null \
			|| echo $i >> "$controldir"/.needs-so
554
	done
Natanael Copa's avatar
Natanael Copa committed
555 556
}

557 558 559 560 561 562 563 564 565 566 567 568 569 570 571 572 573 574 575 576 577 578 579 580 581 582 583
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
	else
		[ "$arch" = "noarch" ] && return 0
		error "No arch specific binaries found so arch should be set to \"noarch\""
		return 1
	fi
	return 0
}

584
prepare_package() {
585
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
586
	stripbin
587 588
	prepare_metafiles && prepare_tracedeps || return 1
	archcheck	
589 590 591 592 593 594 595 596
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

597 598 599 600 601 602 603 604 605 606 607 608 609 610 611 612 613 614 615 616 617 618 619
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

620 621 622
trace_apk_deps() {
	local name="$1"
	local dir="$2"
623
	local i= j= found= autodeps= deppkgs= missing= so_paths=
624
	msg "Tracing dependencies for $name..."
625 626 627
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
628
		msg "  added pkgconfig (found /usr/lib/pkgconfig)"
629 630 631 632
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
633
	if [ -f "$dir"/.needs-so ] && grep -q -w '^libpthread.so.*' "$dir"/.needs-so \
634 635
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
636
		msg "  added libgcc (due to libpthread)"
637
	fi
638
	[ -f "$dir"/.needs-so ] && for i in $(cat "$dir"/.needs-so); do
639
		found=
640
		# first check if its provide by same apkbuild
641
		for j in "$dir"/../.control.*/.provides-so; do
642
			grep -w "$i" "$j" >/dev/null || continue
643
			found=${j%/.provides-so}
644
			found=${found##*/.control.}
645
			break
646
		done
647 648 649 650 651 652
		if [ -n "$found" ]; then
			if ! list_has "$found" $self_provided; then
				self_provided="$self_provided $found"
			fi
		else
			missing="$missing $i"
653
		fi
654 655 656
	done

	# find all packages that holds the so files
657 658 659 660 661
	if [ -f "$dir"/.rpaths ]; then
		so_files=$(find_so_files "$dir"/.rpaths $missing) || return 1
		deppkgs=$($APK info -q -W $so_files) || return 1
	fi

662
	for found in $self_provided $deppkgs; do
663
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
664 665 666
			warning "You can remove '$found' from depends"
			continue
		fi
667 668
		if [ "$found" != "$name" ] && ! list_has "$found" $autodeps; then
			autodeps="$autodeps $found"
669
			msg "  added $found"
670
		fi
671
	done
672

673 674 675 676 677 678 679
	[ -z "$autodeps" ] && return 0
	echo "# automatically detected:" >> "$dir"/.PKGINFO
	for i in $autodeps; do
		echo "depend = $i" >> "$dir"/.PKGINFO
	done
}

680 681
create_apks() {
	local file
682
	getpkgver || return 1
683
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
684 685 686
		local dir="${file%/.PKGINFO}"
		local name=$(pkginfo_val pkgname $file)
		local ver=$(pkginfo_val pkgver $file)
687
		local apk=$name-$ver.apk
688
		local datadir="$pkgbasedir"/$name
689 690

		trace_apk_deps "$name" "$dir" || return 1
691
		msg "Creating $apk..."
692
		(
693 694
		cd "$datadir"
		# data.tar.gz
695 696 697 698 699 700
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
701 702 703 704 705 706

		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
707
		cd "$dir"
708 709
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
710
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
711

712 713 714
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
	)
715 716 717
	done
}

718
update_abuildrepo() {
719
	if ! apk_up2date || [ -n "$force" ]; then
720
		sanitycheck && builddeps && clean && fetch && unpack \
Natanael Copa's avatar
Natanael Copa committed
721
			&& prepare && mkusers && rootpkg || return 1
722
	fi
723

724
	local apk
725 726
	mkdir -p "$abuildrepo" || return 1
	cd "$abuildrepo"
727 728 729 730 731 732 733 734 735

	# remove broken links
	for apk in *.apk; do
		if [ -L "$apk" ] && [ ! -f "$apk" ]; then
			rm -f "$apk"
		fi
	done

	# create links for this package
736
	for apk in $(listpkg); do
737
		ln -sf "$PKGDEST"/$apk "$abuildrepo"/$apk
738 739
	done

740
	msg "Updating the cached abuild repository index..."
741 742 743 744 745
	local sign=".SIGN.RSA.${SIGN_PUBLIC_KEY##*/}"
	local oldindex=
	if [ -f APKINDEX.tar.gz ]; then
		oldindex="--index APKINDEX.tar.gz"
	fi
746
	$APK index $oldindex --output APKINDEX.tar.gz.unsigned \
747 748
		--description "$repo $(cd $startdir && git describe)" \
		*.apk || exit 1
749 750 751
	msg "Signing the index..."
	abuild-sign -q APKINDEX.tar.gz.unsigned || exit 1
	mv APKINDEX.tar.gz.unsigned APKINDEX.tar.gz
Natanael Copa's avatar
Natanael Copa committed
752
	chmod 644 APKINDEX.tar.gz
753 754
}

755
# predefined splitfunc doc
756
default_doc() {
757
	depends="$depends_doc"
758
	install="$install_doc"
Natanael Copa's avatar
Natanael Copa committed
759
	triggers="$triggers_doc"
760
	arch=${arch_doc:-"noarch"}
Natanael Copa's avatar
Natanael Copa committed
761
	local i
762
	for i in doc man info html sgml licenses gtk-doc; do
763 764 765
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
766 767
		fi
	done
768 769 770
	
	rm -f "$subpkgdir/usr/share/info/dir"

771 772 773
#	# compress info and man pages
#	find "$subpkgdir/usr/share" \( -name '*.info' -o -name '*.info-[1-9]' \
#		-o -name '*.[1-9]' \) -exec gzip {} \;
774 775 776 777

	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

Natanael Copa's avatar
Natanael Copa committed
778
#	[ -d "$subpkgdir/usr/share/man" ] && depends="man"
Natanael Copa's avatar
Natanael Copa committed
779 780 781
	return 0
}

782 783 784 785
doc() {
	default_doc
}

786
# predefined splitfunc mod
787
default_mod() {
788
	depends="$kernel $depends_mod"
789
	install="$install_mod"
Natanael Copa's avatar
Natanael Copa committed
790
	for i in firmware modules; do
791 792 793
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
794
			mv "$pkgdir/lib/$i" "$subpkgdir/lib"
Natanael Copa's avatar
Natanael Copa committed
795 796 797 798
		fi
	done
}

799 800 801 802
mod() {
	default_mod
}

803
# predefined splitfunc dev
804
default_dev() {
805
	local i= j=
806
	depends="$pkgname $depends_dev"
807
	install="$install_dev"
Natanael Copa's avatar
Natanael Copa committed
808
	triggers="$triggers_dev"
809 810 811 812
	for i in $origsubpackages; do
		[ "${i%:*}" = "$subpkgname" ] || depends="$depends ${i%:*}"
	done
		
813
	cd "$pkgdir" || return 0
814 815
	for i in usr/include usr/lib/pkgconfig usr/share/aclocal\
			usr/share/gettext usr/bin/*-config	\
816
			usr/share/vala/vapi usr/share/gir-[0-9]*\
817 818 819
			$(find -name include -type d) 		\
			$(find usr/ -name '*.[acho]' -o -name '*.la' \
			2>/dev/null); do
820 821
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
822
			mkdir -p "$d"
823
			mv "$pkgdir/$i" "$d"
824
			rmdir "$pkgdir/${i%/*}" 2>/dev/null
Natanael Copa's avatar
Natanael Copa committed
825 826
		fi
	done
827 828 829 830 831 832 833
	# move *.so links needed when linking the apps to -dev packages
	for i in lib/*.so usr/lib/*.so; do
		if [ -L "$i" ]; then
			mkdir -p "$subpkgdir"/"${i%/*}"
			mv "$i" "$subpkgdir/$i" || return 1
		fi
	done
Natanael Copa's avatar
Natanael Copa committed
834
	return 0
Natanael Copa's avatar
Natanael Copa committed
835 836
}

837 838 839 840
dev() {
	default_dev
}

841 842 843 844
is_function() {
	type "$1" 2>&1 | head -n 1 | egrep -q "is a (shell )?function"
}

Natanael Copa's avatar
Natanael Copa committed
845 846
# build and package in fakeroot
rootpkg() {
847 848 849 850
	local do_build=build
	cd "$startdir"
	if is_function package; then
		build || return 1
851
		do_build=package
852
	fi
Natanael Copa's avatar
Natanael Copa committed
853
	cd "$startdir"
854
	[ -n "$FAKEROOT" ] && msg "Entering fakeroot..."
855
	$FAKEROOT -- "$abuild_path" $color_opt $do_build \
856
		prepare_subpackages \
857
		prepare_language_packs \
858
		prepare_package \
859
		create_apks
Natanael Copa's avatar
Natanael Copa committed
860 861 862
}

srcpkg() {
863
	getpkgver || return 1
864
	local p="$pkgname-$pkgver-$pkgrel"
Natanael Copa's avatar
Natanael Copa committed
865
	local prefix="${startdir##*/}"
Natanael Copa's avatar
Natanael Copa committed
866 867 868 869 870
	local i files="$prefix/APKBUILD"
	for i in $source; do
		files="$files $prefix/${i##*/}"
	done
	mkdir -p "$PKGDEST"
871
	msg "Creating source package $p.src.tar.gz..."
872
	(cd .. && tar -zcf "$PKGDEST/$p.src.tar.gz" $files) 
Natanael Copa's avatar
Natanael Copa committed
873 874
}

Natanael Copa's avatar
Natanael Copa committed
875 876
# return true if arch is supported or noarch
check_arch() {
Natanael Copa's avatar
Natanael Copa committed
877
	list_has $CARCH $arch || [ "$arch" = "noarch" ] || [ "$arch" = "all" ]
Natanael Copa's avatar
Natanael Copa committed
878 879
}

880
# check if package is up to date
881
apk_up2date() {
882
	getpkgver || return 1
883
	local pkg="$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk"
884
	local i s
Natanael Copa's avatar
Natanael Copa committed
885
	cd "$startdir"
886 887 888 889 890
	for i in $pkgname $subpackages; do
		[ -f "$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk" ] || return 1
	done
	[ -n "$keep" ] && return 0

891
	for i in $source APKBUILD; do
892 893 894 895 896 897
		local s
		if is_remote "$i"; then
			s="$SRCDEST/${i##*/}"	# $(basename $i)
		else
			s="$startdir/${i##*/}"
		fi
898 899 900 901 902 903 904
		if [ "$s" -nt "$pkg" ]; then
			return 1
		fi
	done
	return 0
}

905
abuildindex_up2date() {
906
	local i apk
907
	getpkgver || return 1
908 909
	for i in $pkgname $subpackages; do
		apk="${i%:*}-$pkgver-r$pkgrel.apk"
910
		[ "$abuildrepo"/APKINDEX.tar.gz -nt "$abuildrepo"/$apk ] || return 1
911 912 913 914 915
	done
	return 0
}

up2date() {
Natanael Copa's avatar
Natanael Copa committed
916
	check_arch || return 0
917 918 919 920 921 922 923
	apk_up2date && abuildindex_up2date
}

# rebuild package and abuildrepo index if needed
abuildindex() {
	up2date && return 0
	update_abuildrepo
924 925
}

926 927 928 929 930 931 932
# source all APKBUILDs and output:
#  1) origin of package
#  2) all dependencies
# the output is i in a format easy parseable for awk
depparse_aports() {
	# lets run this in a subshell since we source all APKBUILD here
	(
933 934
	aportsdir=$(realpath ${APKBUILD%/APKBUILD}/..)
	for i in $aportsdir/*/APKBUILD; do
935 936 937 938
		pkgname=
		subpackages=
		depends=
		makedepends=
939
		. $i
940
		dir=${i%/APKBUILD}
941
		deps=
942
		# filter out conflicts from deps and version info
943 944 945 946
		for j in $depends $makedepends; do
			case "$j" in
				!*) continue;;
			esac
947
			deps="$deps ${j%%[<>=]*}"
948
		done
949
		for j in $pkgname $subpackages; do
950
			echo "o ${j%%:*} $dir"
951
			set -- $deps
952 953 954 955 956 957 958
			echo -n "d ${j%%:*} $1"
			shift
			while [ $# -gt 0 ]; do
				echo -n ",$1"
				shift
			done
			echo
959 960
		done
	done
961
	)
962 963
}

964
deptrace() {
965 966 967
	local deps= i=
	# strip versions from deps
	for i in "$@"; do
968
		deps="$deps ${i%%[<>=]*}"
969
	done
970
	[ -z "$deps" ] && return 0
971 972 973
	( 	depparse_aports 
		if [ -z "$upgrade" ]; then
			# list installed pkgs and prefix with 'i '
974
			$APK info -q | sort |  sed 's/^/i /'
975
		fi
976
	) | awk -v pkgs="$deps" '
977 978 979 980 981 982 983 984 985 986 987 988 989 990 991 992 993 994 995 996 997 998 999 1000 1001

	function depgraph(pkg,	a, i) {
		if (visited[pkg])
			return 0;
		visited[pkg] = 1;
		split(deps[pkg], a, ",");
		for (i in a)
			depgraph(a[i]);
		print pkg ":" origin[pkg];

	}

	$1 == "i" { visited[$2] = 1 }
	$1 == "o" { origin[$2] = $3 }
	$1 == "d" { deps[$2] = $3 }
	END {
		split(pkgs, pkgarray);
		for (i in pkgarray)
			depgraph(pkgarray[i]);
	}
	'
}

# build and install dependencies
builddeps() {
1002
	local deps= alldeps= pkg= i= dir= ver= missing= installed_deps=
1003
	local filtered_deps= conflicts=
1004
	[ -n "$nodeps" ] && return 0
1005
	msg "Analyzing dependencies..."
1006

1007 1008 1009
	# add depends unless it is a subpackage or package itself
	for i in $BUILD_BASE $depends $makedepends; do
		[ "$pkgname" = "${i%%[<>=]*}" ] && continue
1010
		subpackages_has ${i%%[<>=]*} || deps="$deps $i"
1011 1012
	done

1013
	installed_deps=$($APK info -e $deps)
1014
	# find which deps are missing
1015
	for i in $deps; do
1016
		if [ "${i#\!}" != "$i" ]; then
1017
			$APK info -q -e "${i#\!}" \
1018
				&& conflicts="$conflicts ${i#\!}"
1019
		elif ! deplist_has $i $installed_deps || [ -n "$upgrade" ]; then
1020 1021 1022
			missing="$missing $i"
		fi
	done
1023
	
1024
	if [ -n "$conflicts" ]; then
1025 1026
		error "Conflicting package(s) installed:$conflicts"
		return 1
1027 1028 1029 1030 1031 1032 1033 1034
	fi
	
	if [ -z "$install_deps" ] && [ -z "$recursive" ]; then
		# if we dont have any missing deps we are done now
		[ -z "$missing" ] && return 0
		error "Missing dependencies: $missing Use -r to autoinstall or -R to build"
		return 1
	fi
1035

1036
	uninstall_after=".makedepends-$pkgname $uninstall_after"
1037
	if [ -n "$install_deps" ] && [ -z "$recursive" ] && [ -n "$deps" ]; then
1038 1039
		# make a --simluate run first to detect missing deps
		# apk-tools --virtual is no goot at reporting those.
1040
		$SUDO $APK add --repository "$abuildrepo" \
1041 1042
			--wait 30 \
			--simulate --quiet $deps || return 1
1043
		$SUDO $APK add --repository "$abuildrepo" \
1044
			--wait 30 \
1045 1046
			--virtual .makedepends-$pkgname $deps \
			&& return 0
1047
	fi
1048 1049
	
	[ -z "$recursive" ] && return 1
1050 1051 1052

	# find dependencies that are installed but missing in repo.
	for i in $deps; do
1053
		local m=$($APK search --repository "$abuildrepo" ${i%%[<>=]*})
Natanael Copa's avatar
Natanael Copa committed
1054
		if [ -z "$m" ]; then
1055 1056 1057
			missing="$missing $i"
		fi
	done
1058 1059
	
	for i in $(deptrace $missing); do
1060 1061 1062
		# i = pkg:dir
		local dir=${i#*:}
		local pkg=${i%:*}
1063 1064 1065 1066 1067 1068 1069 1070 1071 1072

		# ignore if dependency is in other repo
		[ -d "$dir" ] || continue
		
		# break cricular deps
		list_has $pkg $ABUILD_VISITED && continue
		export ABUILD_VISITED="$ABUILD_VISITED $pkg"

		msg "Entering $dir"
		cd "$dir" && $0 $forceroot $keep $quiet $install_deps \
1073
			$recursive $upgrade $color_opt abuildindex || return 1
1074
	done
1075
	$SUDO $APK add -u --repository "$abuildrepo" \
1076
		--wait 30 \
1077
		--virtual .makedepends-$pkgname $deps
1078 1079
}

1080
# replace the md5sums in the APKBUILD
Natanael Copa's avatar
Natanael Copa committed
1081 1082
checksum() {
	local s files
1083
	[ -z "$source" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
1084
	fetch
1085
	msg "Updating the md5sums in APKBUILD..."
Natanael Copa's avatar
Natanael Copa committed
1086 1087 1088 1089
	for s in $source; do
		files="$files ${s##*/}"
	done
	md5sums="$(cd "$srcdir" && md5sum $files)" || die "md5sum failed"
1090 1091
	sed -i -e '/^md5sums="/,/"\$/d; /^md5sums=''/,/''\$/d' "$APKBUILD"
	echo "md5sums=\"$md5sums\"" >>"$APKBUILD"
Natanael Copa's avatar
Natanael Copa committed
1092 1093
}

1094
stripbin() {
1095
	local bin
1096 1097 1098
	if options_has "!strip" || [ "$arch" = "noarch" ]; then
		return 0
	fi
1099 1100
	cd "${subpkgdir:-$pkgdir}" || return 1
	msg "Stripping binaries"
1101 1102 1103
	scanelf --recursive --nobanner --etype "ET_DYN,ET_EXEC" . \
		| sed -e 's:^ET_DYN ::' -e 's:^ET_EXEC ::' \
		| xargs -r strip
1104 1105
}

1106 1107
# simply list target apks
listpkg() {
1108
	local name
1109
	getpkgver || return 1
1110 1111
	for name in $(listpkgnames) ; do
		echo "$name-$pkgver-r$pkgrel.apk"
1112 1113 1114
	done
}